# MTWordCount 1.4
# Word count plugin for Movable Type
#
# Copyright 2002 Kalsey Consulting Group
# http://kalsey.com/
# Using this software signifies your acceptance of the license
# file that accompanies this software.
#
# Installation and usage instructions can be found at
# http://kalsey.com/blog/2002/06/word_count_plugin_for_movable_type.stm

use MT::Template::Context;
MT::Template::Context->add_tag(WordCount => sub { &WordCount; });
MT::Template::Context->add_tag(ImageCount => sub { &ImageCount; });

sub WordCount {
	my($ctx) = shift;
    defined(my $entry = $ctx->stash('entry'))
        or return $ctx->error("<MTWordCount> must be used in an entry.");
    my $strText = $entry->text ? strip($entry->text) : '';
    $strText .= $entry->text_more ? strip($entry->text_more) : '';
    my $count = $strText =~ s/((^|\s)\S)/$1/ig;
    $count = $count ? $count : 0;
}

sub ImageCount {
	my($ctx) = shift;
    defined(my $entry = $ctx->stash('entry'))
        or return $ctx->error("<MTImageCount> must be used in an entry.");
    my $strText = $entry->text ? $entry->text : '';
    $strText .= $entry->text_more ? $entry->text_more : '';
    my $imgCount = $strText =~ s/(<img\s[^>]*>)/$1/ig;
    $imgCount = $imgCount ? $imgCount : 0;
}

sub strip () {
	$_ = shift;
	s(<[^>]*>)( )g;
	return $_;
}